<?php
/**
* 2017-2019 Buy Addons Team
*
* NOTICE OF LICENSE
*
* This source file is subject to the GNU General Public License version 3
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://www.opensource.org/licenses/gpl-3.0.html
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@buy-addons.com so we can send you a copy immediately.
*
* @author Buy Addons Team <hatt@buy-addons.com>
* @copyright  2017-2019 Buy Addons Team
* @license   http://www.opensource.org/licenses/gpl-3.0.html  GNU General Public License version 3
* International Registered Trademark & Property of Buy Addons Team
*/

class ProductCommentFilter extends Module
{
    public $demoMode = false;
    public $get_title_comment = '';
    public $get_content_comment = '';
    public $fchar = array('star'=>'*','dollar'=>'$','quest'=>'?','excl'=>'!','hyphen'=>'-','hash'=>'#','tilde'=>'~');
    public function __construct()
    {
        $this->name = 'productcommentfilter';
        $this->tab = 'front_office_features';
        $this->version = '1.0.0';
        $this->author = 'buy-addons';
        $this->need_instance = 0;
        $this->bootstrap = true;
        $this->displayName = $this->l('Product Comment Filter');
        $this->description = $this->l('Allows for filtering of bad words used during commenting.');
        parent:: __construct();
    }

    public function disable($forceAll = false)
    {
        $forceAll;
        $tab = new Tab((int) Tab::getIdFromClassName('AdminProductCommentFilter'));
        $tab->delete();
        if (parent::disable() == false) {
            return false;
        }
        return true;
    }

    public function enable($forceAll = false)
    {
        $forceAll;
        $tab_id = Tab::getIdFromClassName('AdminProductCommentFilter');
        $tab_presmobic = Tab::getIdFromClassName('AdminPressMobileApp');
        if ($tab_presmobic != false && $tab_id === false) {
            $this->installSubmenu('AdminProductCommentFilter', 'Product Comment Filter');
        }
        if (parent::enable() == false) {
            return false;
        }
        return true;
    }

    public function install()
    {
        $db = Db::getInstance(_PS_USE_SQL_SLAVE_);
        //create ps_filter_comment
        $sql_create_1 = 'CREATE TABLE IF NOT EXISTS '._DB_PREFIX_.'filter_comment(
            id_filtercmt int(11) AUTO_INCREMENT,
            keyword_filtercmt varchar(255) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL,
            filter_review_title tinyint(1) NULL,
            words_rendering VARCHAR(10) NULL,
            filter_character VARCHAR(20) NULL,
            case_matching tinyint(1) NULL,
            PRIMARY KEY(id_filtercmt)
        )';
        $db->query($sql_create_1);
        //create product_filter_comment
        $sql_create_2 = 'CREATE TABLE IF NOT EXISTS '._DB_PREFIX_.'product_filter_comment(
            id_product_filter_comment int(10) AUTO_INCREMENT,
            id_product_comment int(10),
            title varchar(64) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
            content text CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
            PRIMARY KEY(id_product_filter_comment))';
        $db->query($sql_create_2);
        //creat filter_comment
        $sql_insert_1 = "INSERT INTO "._DB_PREFIX_."filter_comment (`id_filtercmt`, `keyword_filtercmt`,";
        $sql_insert_1 .= " `filter_review_title`, `words_rendering`, `filter_character`, `case_matching`)";
        $sql_insert_1 .= "VALUES (NULL, 'Fuck, Shit, Pool', 0, 'fi_letter', 'star', '2')";
        $db->query($sql_insert_1);
        $this->setdatadefult();
        $tab_id = Tab::getIdFromClassName('AdminProductCommentFilter');
        $tab_presmobic = Tab::getIdFromClassName('AdminPressMobileApp');
        if ($tab_presmobic != false && $tab_id === false) {
            $this->installSubmenu('AdminProductCommentFilter', 'Product Comment Filter');
        }
        if (parent::install() == false) {
            return false;
        }
        $this->registerHook("actionObjectProductCommentAddBefore");
        $this->registerHook("actionObjectProductCommentAddAfter");
        $this->registerHook("presmobicSubmitComment");
        $this->registerHook("presmobicAfterSubmitComment");
        return true;
    }
    
    public function uninstall()
    {
        $db = Db::getInstance(_PS_USE_SQL_SLAVE_);
        $sql = 'DROP TABLE IF EXISTS '._DB_PREFIX_.'filter_comment';
        $db->query($sql);
        $sql ='SELECT `id_product_comment`, `title`, `content` FROM '._DB_PREFIX_.'product_filter_comment';
        $data_comment = $db->ExecuteS($sql);
        foreach ($data_comment as $key => $value) {
            $key;
            $sql = 'UPDATE '._DB_PREFIX_.'product_comment SET 
                title      = "'.pSQL($value["title"]).'",
                content      = "'.pSQL($value["content"]).'"
                WHERE id_product_comment = '.(int)$value["id_product_comment"].'';
            $db->query($sql);
        }
        $sql = 'DROP TABLE IF EXISTS '._DB_PREFIX_.'product_filter_comment';
        $db->query($sql);
        $tab = new Tab((int) Tab::getIdFromClassName('AdminProductCommentFilter'));
        $tab->delete();
        if (parent::uninstall() == false) {
            return false;
        }
        return true;
    }

    public function getContent()
    {
        $html ='';
        if (Module::isInstalled("productcomments")) {
            $db = Db::getInstance(_PS_USE_SQL_SLAVE_);
            $url = Tools::getShopProtocol() . Tools::getServerName() . __PS_BASE_URI__;
            //var_dump($data );die;
            if (Tools::isSubmit('save')) {
                if ($this->demoMode == false) {
                    $get_words_rendering = (string) Tools::getValue('words_rendering');
                    $get_case_matching = (int) Tools::getValue('case_matching');
                    $get_filter_title = (int) Tools::getValue('filter-title');
                    $get_keywords = (string) Tools::getValue('keywords');
                    $get_filter_char = (string) Tools::getValue('filter_char');
                    $sql = "UPDATE "._DB_PREFIX_."filter_comment SET 
                        keyword_filtercmt      = '".pSQL(trim($get_keywords))."',
                        filter_review_title      = '".(int)$get_filter_title."',
                        words_rendering     = '".pSQL($get_words_rendering)."',
                        filter_character        = '".pSQL($get_filter_char)."',
                        case_matching   = '".(int)$get_case_matching."'";
                    $check_save = $db->query($sql);
                    if ($check_save) {
                        $html .= $this->displayConfirmation($this->l('Update Success!'));
                    }
                    $sql_select ='SELECT `id_product_comment`, `title`,`content`';
                    $sql_select .=' FROM '._DB_PREFIX_.'product_filter_comment';
                    $data_comment_defult = $db->ExecuteS($sql_select);
                    $wildcard = ''.$this->fchar[$get_filter_char].'';
                    $db_search_string = trim($get_keywords);
                    $keywords = array_map('trim', explode(',', $db_search_string)); // explode and trim whitespace
                    $keywords = array_unique($keywords); // get rid of duplicates in the keywords textbox
                    $words_rd = $get_words_rendering;
                    $filter_type = $get_case_matching;
                    $whole = true;
                    foreach ($data_comment_defult as $key => $value) {
                        $fconte = $value['content'];
                        $ftitle = $value['title'];
                        foreach ($keywords as $kew) {
                            $kew = trim($kew);
                            if (Tools::strlen($kew) > 2) {
                                $replacement = $this->censorWord($words_rd, $kew, $wildcard);
                                if ($filter_type == "2") {
                                    $kw2 = $kew;
                                    $rplm = $replacement;
                                    $wrd = $words_rd;
                                    $fconte = $this->strReplaceI($kw2, $rplm, $fconte, $wrd, $kew, $wildcard, $whole);
                                    $ftitle = $this->strReplaceI($kw2, $rplm, $ftitle, $wrd, $kew, $wildcard, $whole);
                                } else {
                                    $fconte = $this->strReplaceSe($kew, $replacement, $fconte, $whole);
                                    $ftitle = $this->strReplaceSe($kew, $replacement, $ftitle, $whole);
                                }
                            }
                        }
                        $data_comment_defult[$key]['content'] = $fconte;
                        if ($get_filter_title == 1) {
                            $data_comment_defult[$key]['title'] = $ftitle;
                        }
                    }
                    foreach ($data_comment_defult as $key2 => $value2) {
                        $key2;
                        $sqls = 'UPDATE '._DB_PREFIX_.'product_comment SET 
                            title      = "'.pSQL($value2["title"]).'",
                            content      = "'.pSQL($value2["content"]).'"
                            WHERE id_product_comment = '.(int)$value2["id_product_comment"].'';
                        $db->query($sqls);
                    }
                }
            }
            //var_dump($data);die;
            $data_return = $this->getDataFilterComment('filter_comment');
            $this->context->smarty->assign('data_return', $data_return);
            $this->context->smarty->assign('baseDir', $url);
            $this->context->smarty->assign('demoMode', $this->demoMode);
            $html .= $this->display(__FILE__, 'views/templates/admin/filter-comment-setting.tpl');
        } else {
            $error_alert = 'You must install the "Product Comments" module before use this module.';
            $html .= $this->displayError($this->l($error_alert));
        }
        return $html;
    }

    public function hookactionObjectProductCommentAddBefore(& $params)
    {
        $this->get_title_comment = $params['object']->title;
        $this->get_content_comment = $params['object']->content;
        $data_return =  $this->getDataFilterComment('filter_comment');
        //var_dump($data_return);die;
        $wildcard = $this->fchar[$data_return[0]['filter_character']];
        $db_search_string = trim($data_return[0]['keyword_filtercmt']);
        $keywords = array_map('trim', explode(',', $db_search_string)); // explode and trim whitespace
        $keywords = array_unique($keywords); // get rid of duplicates in the keywords textbox
        $w_rend = $data_return[0]['words_rendering'];
        $k_mat = $data_return[0]['case_matching'];
        $cmtcontent = $params['object']->content;
        $cmt_title = $params['object']->title;
        $whole_word = true;
        foreach ($keywords as $kw) {
            $kw = trim($kw);
            if (Tools::strlen($kw) > 2) {
                $replace = $this->censorWord($w_rend, $kw, $wildcard);
                if ($k_mat == "2") {
                    $cmtcontent = $this->strReplaceI($kw, $replace, $cmtcontent, $w_rend, $kw, $wildcard, $whole_word);
                    $cmt_title = $this->strReplaceI($kw, $replace, $cmt_title, $w_rend, $kw, $wildcard, $whole_word);
                } else {
                    $cmtcontent = $this->strReplaceSe($kw, $replace, $cmtcontent, $whole_word);
                    $cmt_title = $this->strReplaceSe($kw, $replace, $cmt_title, $whole_word);
                }
            }
        }
        $params['object']->content = $cmtcontent;
        if ($data_return[0]['filter_review_title'] == 1) {
            $params['object']->title = $cmt_title;
        }
    }

    public function hookactionObjectProductCommentAddAfter(& $params)
    {
        $id_comment = $params['object']->id;
        $title = $this->get_title_comment;
        $content = $this->get_content_comment;
        $db = Db::getInstance(_PS_USE_SQL_SLAVE_);
        $sql_insert = 'INSERT INTO '._DB_PREFIX_.'product_filter_comment';
        $sql_insert .= '(`id_product_filter_comment`,`id_product_comment`, `title`, `content`)';
        $sql_insert .= 'VALUES (NULL, "'.(int)$id_comment.'",';
        $sql_insert .= ' "'.pSQL($title).'","'.pSQL($content).'")';
        $db->query($sql_insert);
    }
    
    public function hookpresmobicSubmitComment(& $params)
    {
        $this->get_title_comment = $params['comment']['comment_name'];
        $this->get_content_comment = $params['comment']['comment_descriprtion'];
        $data_return =  $this->getDataFilterComment('filter_comment');
        //var_dump($data_return);die;
        $wildcard = $this->fchar[$data_return[0]['filter_character']];
        $db_search_string = trim($data_return[0]['keyword_filtercmt']);
        $keywords = array_map('trim', explode(',', $db_search_string)); // explode and trim whitespace
        $keywords = array_unique($keywords); // get rid of duplicates in the keywords textbox
        $w_rend = $data_return[0]['words_rendering'];
        $k_mat = $data_return[0]['case_matching'];
        $cmtcontent = $params['comment']['comment_descriprtion'];
        $cmt_title = $params['comment']['comment_name'];
        $whole_word = true;
        foreach ($keywords as $kw) {
            $kw = trim($kw);
            if (Tools::strlen($kw) > 2) {
                $replace = $this->censorWord($w_rend, $kw, $wildcard);
                if ($k_mat == "2") {
                    $cmtcontent = $this->strReplaceI($kw, $replace, $cmtcontent, $w_rend, $kw, $wildcard, $whole_word);
                    $cmt_title = $this->strReplaceI($kw, $replace, $cmt_title, $w_rend, $kw, $wildcard, $whole_word);
                } else {
                    $cmtcontent = $this->strReplaceSe($kw, $replace, $cmtcontent, $whole_word);
                    $cmt_title = $this->strReplaceSe($kw, $replace, $cmt_title, $whole_word);
                }
            }
        }
        $params['comment']['comment_descriprtion'] = $cmtcontent;
        if ($data_return[0]['filter_review_title'] == 1) {
            $params['comment']['comment_name'] = $cmt_title;
        }
    }

    public function hookpresmobicAfterSubmitComment(& $params)
    {
        $id_comment = $params['id_comment_add'];
        $title = $this->get_title_comment;
        $content = $this->get_content_comment;
        $db = Db::getInstance(_PS_USE_SQL_SLAVE_);
        $sql_insert = 'INSERT INTO '._DB_PREFIX_.'product_filter_comment';
        $sql_insert .= '(`id_product_filter_comment`,`id_product_comment`, `title`, `content`)';
        $sql_insert .= 'VALUES (NULL, "'.(int)$id_comment.'",';
        $sql_insert .= ' "'.pSQL($title).'","'.pSQL($content).'")';
        $db->query($sql_insert);
    }

    public function getDataFilterComment($db_name)
    {
        $db = Db::getInstance(_PS_USE_SQL_SLAVE_);
        $sql ='SELECT * FROM '._DB_PREFIX_.$db_name;
        return $db->ExecuteS($sql);
    }

    public function setdatadefult()
    {
        if (Module::isInstalled("productcomments")) {
            $db = Db::getInstance(_PS_USE_SQL_SLAVE_);
            // Get product_comment data.
            $sql ='SELECT `id_product_comment`, `title`, `content` FROM '._DB_PREFIX_.'product_comment';
            $data_comment = $db->ExecuteS($sql);
            //Begin filter comment.
            $wildcard = '*';
            $db_search_string = 'Fuck, Shit, Pool';
            $keywords = array_map('trim', explode(',', $db_search_string));
            $keywords = array_unique($keywords);
            $words_rd = 'fi_letter';
            $filter_type = '2';
            $wholew = true;
            if ($data_comment) {
                foreach ($data_comment as $key => $value) {
                    $sql_insert = 'INSERT INTO '._DB_PREFIX_.'product_filter_comment';
                    $sql_insert .='(`id_product_filter_comment`,`id_product_comment`, `title`, `content`)';
                    $sql_insert .= 'VALUES (NULL, "'.(int)$value["id_product_comment"].'",';
                    $sql_insert .= ' "'. pSQL($value["title"]).'", "'. pSQL($value["content"]).'")';
                    $db->query($sql_insert);
                    $text = $value['content'];
                    foreach ($keywords as $keyword) {
                        $keyword = trim($keyword);
                        if (Tools::strlen($keyword) > 2) {
                            $replacement = $this->censorWord($words_rd, $keyword, $wildcard);
                            if ($filter_type == "2") {
                                $kw = $keyword;
                                $rplm = $replacement;
                                $text = $this->strReplaceI($kw, $rplm, $text, $words_rd, $keyword, $wildcard, $wholew);
                            } else {
                                $text = $this->strReplaceSe($keyword, $replacement, $text, $wholew);
                            }
                        }
                    }
                    $data_comment[$key]['content'] = $text;
                }
                //End filter comment.
                //Update data after filter.
                foreach ($data_comment as $key => $value) {
                    $sql = 'UPDATE '._DB_PREFIX_.'product_comment SET 
                        content      = "'.pSQL($value["content"]).'"
                        WHERE id_product_comment = '.(int)$value["id_product_comment"].'';
                    $db->query($sql);
                }
            }
        }
    }

    public function strReplaceSe($needle, $replacement, $haystack, $whole_word = true)
    {
        $needle   = str_replace('/', '\\/', preg_quote($needle)); // allow '/' in keywords
        $pattern  = $whole_word ? "/\b$needle\b/" : "/$needle/";
        $haystack = preg_replace($pattern, $replacement, $haystack);
        return $haystack;
    }

    public function strReplaceI($needle, $replacement, $haystack, $words_rd, $keyword, $wildcard, $whole_word = true)
    {
        $replacement;
        $needle   = str_replace('/', '\\/', preg_quote($needle)); // allow '/' in keywords
        $pattern  = $whole_word ? "/\b$needle\b/i" : "/$needle/i";
        $haystack = preg_replace_callback(
            $pattern,
            function ($m) use ($words_rd, $keyword, $wildcard) {
                $keyword;
                if ($words_rd == 'fi_letter') {
                    $m[0] = Tools::substr($m[0], 0, 1) . str_repeat($wildcard, Tools::strlen(Tools::substr($m[0], 1)));
                } else {
                    if ($words_rd == 'all_letter') {
                        $m[0] = str_repeat($wildcard, Tools::strlen(Tools::substr($m[0], 0)));
                    } else {
                        $letter = str_repeat($wildcard, Tools::strlen(Tools::substr($m[0], 2)));
                        $m[0] = Tools::substr($m[0], 0, 1) . $letter .Tools::substr($m[0], - 1, 1);
                    }
                }
                return $m[0];
            },
            $haystack
        );
        return $haystack;
    }
    
    public function censorWord($words_rd, $keyword, $wildcard)
    {
        if ($words_rd == 'fi_letter') {
            $keyword = Tools::substr($keyword, 0, 1) . str_repeat($wildcard, Tools::strlen(Tools::substr($keyword, 1)));
        } else {
            if ($words_rd == 'all_letter') {
                $keyword = str_repeat($wildcard, Tools::strlen(Tools::substr($keyword, 0)));
            } else {
                $letter = str_repeat($wildcard, Tools::strlen(Tools::substr($keyword, 2)));
                $keyword = Tools::substr($keyword, 0, 1) . $letter . Tools::substr($keyword, - 1, 1);
            }
        }
        return $keyword;
    }
    public function installSubmenu($className, $tabName, $tabParentName = true)
    {
        $tab = new Tab();
        $tab->active = 1;
        $tab->class_name = $className;
        $tab->name = array();
        $tabParentName = 'AdminPressMobileApp';
        $tab->position = 6;
        foreach (Language::getLanguages(true) as $lang) {
            $tab->name[$lang['id_lang']] = $tabName;
        }
        if ($tabParentName) {
            $tab->id_parent = (int) Tab::getIdFromClassName($tabParentName);
        } else {
            $tab->id_parent = 0;
        }
        $tab->module = $this->name;
        $tab->add();
        return $tab->save();
    }
}
